= (Match (PATTERN "xxx" 123 'a) '("xxx" 123 a))
  #t

= (Match (PATTERN "xxx" 123 'a) '("xxx" 124 a))
  #f

= (Match (PATTERN "xxx" ? 'a) '("xxx" 123 a))
  #t
  
= (Match (PATTERN "xxx" ?+) '("xxx" 123 a))
  #t
  
= (Match (PATTERN "xxx" (? 'x) 'a) '("xxx" 123 a))
  ((x 123))
  
= (Match (PATTERN "xxx" (? 'x) (? 'y)) '("xxx" 123 a))
  ((x 123) (y a))
  
= (Match (PATTERN "xxx" (?+ 'x)) '("xxx" 123 a))
  ((x (123 a)))
  
= (Match (PATTERN "xxx" (? 'x) (<-? 'x)) '("xxx" 123 123))
  ((x 123))
  
= (Match (PATTERN "xxx" (?+ 'x) (<-? 'x)) '("xxx" 123 124 123 124))
  ((x (123 124)))

! (define isxnumber?
    (lambda (aList)
      (number? (GetAssociationValue 'x aList))))
  
! (define isxpositive?
    (lambda (aList)
      (positive? (GetAssociationValue 'x aList))))
  
= (Match (PATTERN "xxx" (? 'x isxnumber? isxpositive?)) '("xxx" 123))
  ((x 123))
  
= (Match (PATTERN "xxx" (? 'x isxnumber? isxpositive?)) '("xxx" -123))
  #f

= (Match (PATTERN "xxx" (PATTERN 1 (? 'x)) (? 'y)) '("xxx" (1 3) 123))
  ((x 3) (y 123))

= (Match (PATTERN "xxx" (<-? 'x)) '("xxx" 123) '((x 123)))
  ((x 123))
  
* (Match (PATTERN "xxx" (<-? 'x)) '("xxx" 123) '((x 123)) 'extra)

* (Match (PATTERN (? 'x) (<-? 'y)) '(123 123 124))

= (Match (PATTERN "xxx" (?+ 'x)) '("xxx" 123) '((x (122))))
  ((x (122 123)))

= (Match (PATTERN "xxx" (?+ 'x)) '("xxx" 123) '((x 122)))
  ((x (123)))

; examples from section 3.3.2 of book
  

=	(Match (PATTERN "unlucky number" 13 '!) 
	       '("unlucky number" 13 !) )            	   
	 #t
  
=	(Match (PATTERN "unlucky number" 42 '!) 
		      '("unlucky number" 13 !))            	   
	 #f
  
=	(Match (PATTERN "unlucky number" ? '!)   
		       '("unlucky number" 13 !))
  #t
  
=	(Match (PATTERN "unlucky number" ?+)
         '("unlucky number" 13 !))
  #t

=	(Match '("unlucky number" ?) '("unlucky number" 13))
	 #f
  
=	(Match '("unlucky number" ?) '("unlucky number" ?))
	 #t

=	(Match (PATTERN "unlucky number" (? 'x) '!) 
		       '("unlucky number" 13 !))
  ((x 13))
  
=	(Match (PATTERN "unlucky number" (? 'x) (? 'y))
         '("unlucky number" 13 !))
  ((x 13)  (y !))
  
=	(Match (PATTERN "unlucky number" (?+ 'x))
         '("unlucky number" 13 !))
  ((x (13 !)))


=	(Match (PATTERN "unlucky number" (? 'x) (<-? 'x))
         '("unlucky number" 13 13))
  ((x 13))
  
=	(Match (PATTERN "unlucky numbers" (?+ 'x) (<-? 'x))
	        '("unlucky numbers" 7 13 7 13))
  ((x (7 13)))

=	(Match (PATTERN "unlucky number" 
                  (? 'x  ; predicate for checking if x is "positive" 
                     (lambda (anAList)
                       (positive?
                        ; get current binding for x  (just made !)
                        (GetAssociationValue 
                         'x 
                         anAlist))) ))
         '("unlucky number" 13))
  ((x 13))

=	(Match (PATTERN "unlucky number" 
                  (? 'x ; test for positiveness
                     (lambda (anAList)
                       (positive? 
                        (GetAssociationValue 
                         'x 
                         anAlist)))
                     ; test for evenness 
                     (lambda (anAList)
                       (even? 
                        (GetAssociationValue 
                         'x 
                         anAlist))) ))
         '("unlucky number" 13))
  #f
  
=	(Match (PATTERN "secret of success:" 
                  (PATTERN (? 'x) 'attitude) (? 'y))
         '("secret of success:" (positive attitude) !))
  ((x positive) (y !))

= (Match (PATTERN "unlucky number" (<-? 'x)) ; a pattern
         '("unlucky number" 13)               ; a list
         '((x 13)))  				  ; an Alist
  ((x 13))
